<%@ Page Language="C#" MasterPageFile="~/DefaultMaster.master" AutoEventWireup="true"
    Inherits="CommonPage" Title="ASP.NET AJAX Control Toolkit" %>

<asp:Content ID="Content1" ContentPlaceHolderID="SampleContent" runat="Server">
    <p>
        Welcome to the ASP.NET AJAX Control Toolkit sample website. Please choose from any
        of the samples on the left.
    </p>
    <br />
    <p>
        <strong><u>Installation Files</u></strong></p>
    <br />
    <p>
        Please visit the
        <asp:HyperLink ID="HyperLink4" runat="server" NavigateUrl="http://www.codeplex.com/Wiki/View.aspx?ProjectName=AtlasControlToolkit">AJAX Control Toolkit Project Page</asp:HyperLink>
        on CodePlex</p>
    <br />
    <p>
        <strong><u>Release Notes</u></strong></p>
    <br />
    <p>
        <u><strong>Version 1.0.10920.0</strong></u></p>
    <p>
    </p>
    <br />
    It has two flavors that work against two versions of the .NET Framework:<br />
    <ul>
        <li>ASP.NET AJAX version 1.0 and .NET Framework 2.0</li>
        <li>.NET Framework 3.5 Beta 2 (includes ASP.NET AJAX), <a href="#Framework3.5">details
            below</a></li>
    </ul>
    <p>
    </p>
    <br />
    <p>
        The TemplateVSI project has a dependency on vjslib.dll which is a part of the Visual
        J# Redistributable Package. If you would like to build that project successfully
        then please install the package from <a href="http://www.microsoft.com/downloads/details.aspx?familyid=f72c74b3-ed0e-4af8-ae63-2f0e42501be1&displaylang=en">
            here</a>.
    </p>
    <p>
    </p>
    <br />
    <strong>General fixes:</strong>
    <ul class="releaseList">
        <li><strong>Controls with Embedded styles (Calendar, Tabs and Slider): </strong>Toolkit
            controls no longer need explicit style references when loaded asynchronously. For
            example, if a Calendar control is placed inside an UpdatePanel and made visible
            on an UpdatePanel postback, the embedded styles are now loaded properly.</li>
        <li><strong>PopupBehavior positioning (AutoComplete, Calendar, DropDown, HoverMenu,
            ListSearch, PopupControl and ValidatorCallout):</strong> PopupBehavior now respects
            the position of its parent element even when the browser window is very narrow or
            the parent element is close the window edge.</li>
        <li><strong>Focusing extended controls (Accordion, CollapsiblePanel, DropShadow, Tabs):</strong>
            Pages that use Toolkit controls which re-parent DOM elements can use a workaround
            to focus a specific element on page load. The new method Utility.SetFocusOnLoad ensures
            that the desired control receives focus.</li>
    </ul>
    <p>
    </p>
    <br />
    <p>
        <strong>Control specific fixes:</strong>
    </p>
    <ul class="releaseList">
        <li><strong>Calendar: </strong>Property to specify the position of Calendar, a default
            date feature that allows the calendar to start out with a selected date, and a consistent
            show, hide and focus story that makes the Calendar user experience more intuitive.</li>
        <li><strong>ModalPopup: </strong>Ability to disable repositioning of the ModalPopup in response
            to window resize and scroll.</li>
        <li><strong>ConfirmButton: </strong>ModalPopup functionality now supported in addition
            to the regular windows alert dialog.</li>
        <li><strong>MaskedEdit: </strong>Extended Textbox no longer uses Invariant culture if
            no CultureName is specified and falls back to the Page Culture.</li>
        <li><strong>AutoComplete: </strong>Allow users to associate additional
            data with the AutoComplete suggestions.</li>
        <li><strong>Slider: </strong>Slider can be easily customized using its various CSS properties.</li>
    </ul>
    <br />
    <p>
        Breaking Changes:</p>
    <p>
    </p>
    <ul class="releaseList">
        <li>No breaking changes</li>
    </ul>
    <p>
    </p>
    <p>
        Known Issues:</p>
    <p>
    </p>
    <ul class="releaseList">
        <li>No new issues</li>
    </ul>
    <br />
    <br />
    <p>
        <a name="Framework3.5"></a><u><strong>Toolkit for .NET Framework 3.5 Beta 2 and Visual
            Studio 2008 Beta 2:</strong></u>
    </p>
    This is the second Toolkit version that also has a flavor that is supported on .NET
    3.5 Framework Beta 2 and Visual Studio 2008 Beta 2. If you are trying out Beta 2
    then you can also try out the Toolkit with it.
    <br />
    <br />
    <strong>Note: </strong>This Toolkit flavor is <em>only</em> for users who are using
    Beta 2. If you are not using Beta 2 and you attempt to use this flavor of the Toolkit
    against .NET Framework 2.0 and Visual Studio 2005 it is <em>not</em> supported and
    will not work.
    <br />
    <br />
    <strong>Setting up the environment to use the Toolkit with Beta 2:</strong>
    <ul class="releaseList">
        <li>Follow the instructions to download and install Beta 2 from <a href="http://msdn2.microsoft.com/en-us/vstudio/aa700831.aspx">
            here</a>.</li>
        <li>Download the <strong>AjaxControlToolkit-Framework3.5.zip</strong> or <strong>AjaxControlToolkit-Framework3.5-NoSource.zip</strong>
            from the <a href="http://www.codeplex.com/AtlasControlToolkit/Release/ProjectReleases.aspx">
                Toolkit Releases page</a>. </li>
    </ul>
    <br />
    <strong>Features: </strong>
    <ul class="releaseList">
        <li><strong>JavaScript IntelliSense support: </strong>We have added
            reference tags to all Toolkit JavaScript files that enables you to take advantage of
            new features in Visual Studio 2008 Beta 2. With the multi-targeting support in
            this Visual Studio Beta, IntelliSense will be available for the ASP.NET AJAX 1.0
            flavor of the Toolkit as well. This <a href="http://blogs.msdn.com/webdevtools/archive/2007/03/02/jscript-IntelliSense-in-orcas.aspx">
                article</a> discusses the reference tag feature in detail.</li>
        <li><strong>Extender designer support: </strong>Enhanced designer support for Toolkit
            controls using the new "Add Extender" user interface.</li>
    </ul>
    <br />
    <strong>Known issues with the Toolkit and Beta 2: </strong>
    <ul class="releaseList">
        <li>Pages with controls using Toolkit Animations may not work properly if edited in
            design mode. This is a known issue with Beta 2 and should be fixed in future releases.
        </li>
    </ul>
    <br />
    <br />
    Link to Toolkit Release <a href="ArchivedReleases.aspx">archive</a> .</asp:Content>
